Subject: RE: Multiple-topology IS-IS [RE: [Isis-wg] Feedback on IS-IS AutomaticEncapsulation]

From: "Tony Li" <[email-masked]>
Date: Wed, 23 Jul 2003 10:07:50 -0700

|    Which turns out to be difficult in practice.  You need the
|    multi-topology stuff.  Then all you need is a conneted 
|    path & things
|    work.  If you have to have working software on supported hardware
|    even on just a convex topology before things work, you may never
|    get there.

Andrew,

Is the full-blown complexity of the MT stuff necessary?  Do we 
really need to worry about X forming an adajacnecy with Y and 
the full set of protocol interactions?

If this has to work, we may also never get there.

Tony

_______________________________________________
Isis-wg mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/isis-wg

---

From: Hannes Gredler <[email-masked]>
Date: Sat, 26 Jul 2003 13:41:21 +0200

On Wed, Jul 23, 2003 at 10:07:50AM -0700, Tony Li wrote:
| 
| 
| |    Which turns out to be difficult in practice.  You need the
| |    multi-topology stuff.  Then all you need is a conneted 
| |    path & things
| |    work.  If you have to have working software on supported hardware
| |    even on just a convex topology before things work, you may never
| |    get there.
| 
| 
| Andrew,
| 
| Is the full-blown complexity of the MT stuff necessary?  Do we 
| really need to worry about X forming an adajacnecy with Y and 
| the full set of protocol interactions?
| 
| If this has to work, we may also never get there.

all,

given that some customers have already made their mind that
they do

1. not want a parallel v6 controlplane [neither MT nor self-
   restriction to convex topologies] but rather

2. re-use the exisiting v4 control-plane and

3. use a unified tranport [=MPLS] for connecting the v6 clouds together

the discussion is IMHO obsolete -

actually here we have a nice example how MPLS can make things
overall much simpler; 

i know the v6 bigots do not like that take, but i am afraid
in the next years to come there won't be any 6-only networks;

/hannes

---

From: Naiming Shen <[email-masked]>
Date: Tue, 29 Jul 2003 11:27:54 -0700

] 
 ] actually here we have a nice example how MPLS can make things
 ] overall much simpler; 
 ] 
 ] i know the v6 bigots do not like that take, but i am afraid
 ] in the next years to come there won't be any 6-only networks;

i don't think we are talking about 6-only networks. people are
mainly interested in dual-mode, transition and isolated single/dual
mode islands in the networks. yes, mpls can be a way to bridge the
transition(assume those networks want to use mpls in their backbones),
but to my knowledge, to bridge some isolated V6 regions(still mostly
dual-mode) together, it's so easy to use a couple of tunnels. i agree
that one can use OSPF for ipv4 and ISIS/OSPFv3 for ipv6 to decouple the
topologies in the domain, M-ISIS is just another simple way to create
such a decoupled topologies. 

 ] /hannes

- Naiming

---

From: [email-masked]
Date: Tue, 29 Jul 2003 22:04:14 +0100

This is where things get weird.

Suppose you have a real topology that goes A-B-C-D-E-F

So you make a tunnel from A to F because B-C-D-E don't support v6.

Do you want to make a static route to force the v6 packets down the tunnel ?

Maybe not, so you run IS-IS over the tunnel as well.

Oh but the tunnel had better be more attractive to packets than the real path.

Now all your v4 packets go down the tunnel as well even though they don't need to.

So you have to run OSPFv3 on the tunnel instead and redistribute to IS-IS at each end 
or something.

I think autoencap is easier :-)

Philip

---

From: [email-masked]
Date: Tue, 29 Jul 2003 22:19:15 +0100

Oh yes, I forgot that the MT spf can ignore the IPv4 nodes and therefore only include 
the tunnel as it is a direct adjacency between two nodes that are in the MT.

But, you still have to stop legacy IS-IS from using the tunnel.

What if C or D blow up ?

Presumably the tunnel will go another way, but its metric won't change to reflect the new 
route.

What if the tunnel now becomes more attractive to v4 than the backup path?

Philip

---

From: Naiming Shen <[email-masked]>
Date: Tue, 29 Jul 2003 14:14:30 -0700

] This is where things get weird.
 ] 
 ] Suppose you have a real topology that goes A-B-C-D-E-F
 ] 
 ] So you make a tunnel from A to F because B-C-D-E don't support v6.
 ] 
 ] Do you want to make a static route to force the v6 packets down the tunnel ?
 ] 
 ] Maybe not, so you run IS-IS over the tunnel as well.
 ] 
 ] Oh but the tunnel had better be more attractive to packets than the real pat
h.
 ] 
 ] Now all your v4 packets go down the tunnel as well even though they don't ne
ed to.
 ] 

Hur? i think you're talking about tunnels with "normal" IGP, but i was
talking about tunnels with M-ISIS. with M-ISIS, you just "label" this
tunnel link as ipv6-only, and ipv4 topology(thus spf) in your network
does not even know such a tunnel link exist. this is equivalent to use
ISIS for ipv4, but use ospfv3 on the tunnel links.

hope this helps.

thanks.

 ] So you have to run OSPFv3 on the tunnel instead and redistribute to IS-IS at
 each end 
 ] or something.
 ] 
 ] I think autoencap is easier :-)
 ] 
 ] Philip
 ] 
 ] 
 ] 
 ] On 29 Jul 2003 at 11:27, Naiming Shen wrote:
 ] 
 ] >  ] 
 ] >  ] actually here we have a nice example how MPLS can make things
 ] >  ] overall much simpler; 
 ] >  ] 
 ] >  ] i know the v6 bigots do not like that take, but i am afraid
 ] >  ] in the next years to come there won't be any 6-only networks;
 ] > 
 ] > i don't think we are talking about 6-only networks. people are
 ] > mainly interested in dual-mode, transition and isolated single/dual
 ] > mode islands in the networks. yes, mpls can be a way to bridge the
 ] > transition(assume those networks want to use mpls in their backbones),
 ] > but to my knowledge, to bridge some isolated V6 regions(still mostly
 ] > dual-mode) together, it's so easy to use a couple of tunnels. i agree
 ] > that one can use OSPF for ipv4 and ISIS/OSPFv3 for ipv6 to decouple the
 ] > topologies in the domain, M-ISIS is just another simple way to create
 ] > such a decoupled topologies. 
 ] > 
 ] >  ] /hannes
 ] > 
 ] > - Naiming
 ] > 
 ] > _______________________________________________
 ] > Isis-wg mailing list
 ] > [email-masked]
 ] > https://www1.ietf.org/mailman/listinfo/isis-wg
 ] 
 ] 

- Naiming

---

From: [email-masked]
Date: Tue, 29 Jul 2003 22:28:52 +0100

Yeah, I messed up.
But.....
Suppose you label this tunnel as IPv6 only.
How does the legacy IS-IS (not MT capable) know to ignore it ?

It's still an IS-IS adjacency as far as legacy IS-IS is concerned.  Or isn't it ?

Philip

---

From: Naiming Shen <[email-masked]>
Date: Tue, 29 Jul 2003 14:26:07 -0700

] Oh yes, I forgot that the MT spf can ignore the IPv4 nodes and therefore onl
y include 
 ] the tunnel as it is a direct adjacency between two nodes that are in the MT.
 ] 
 ] But, you still have to stop legacy IS-IS from using the tunnel.
 ] 

for the MT extension, legacy IS-IS, which is ipv4 unicast topology, does
not know about this ipv6-only link.

 ] What if C or D blow up ?
 ] 
 ] Presumably the tunnel will go another way, but its metric won't change to re
flect the new 
 ] route.

if C or D is the only path for the tunnel, then there is no connection
anyway, otherwise, IGP should reroute. if you only have a tunnel to
connect two isolated islands, metric does not play any role here. this
is no difference from using ISIS for ipv4 and ospfv3 for ipv6 case.

usually using IP tunnel as IGP link can cause unexpected result if used
inproperly. but for this application, the tunnel itself and IGP link
belong to different address family and there is no dependancy there.

 ] 
 ] What if the tunnel now becomes more attractive to v4 than the backup path?

same as above, v4 spf just does not know there is such a tunnel link.
(unless operators intentionally make this tunnel to run both ipv6 and
 ipv4 backup(v4 metric really high comparing to hop-by-hop)).

thanks.

 ] 
 ] Philip
 ] 
 ] On 29 Jul 2003 at 22:04, [email-masked] wrote:
 ] 
 ] > This is where things get weird.
 ] > 
 ] > Suppose you have a real topology that goes A-B-C-D-E-F
 ] > 
 ] > So you make a tunnel from A to F because B-C-D-E don't support v6.
 ] > 
 ] > Do you want to make a static route to force the v6 packets down the tunnel
 ?
 ] > 
 ] > Maybe not, so you run IS-IS over the tunnel as well.
 ] > 
 ] > Oh but the tunnel had better be more attractive to packets than the real p
ath.
 ] > 
 ] > Now all your v4 packets go down the tunnel as well even though they don't 
need to.
 ] > 
 ] > So you have to run OSPFv3 on the tunnel instead and redistribute to IS-IS 
at each end 
 ] > or something.
 ] > 
 ] > I think autoencap is easier :-)
 ] > 
 ] > Philip
 ] > 
 ] > 
 ] > 
 ] > On 29 Jul 2003 at 11:27, Naiming Shen wrote:
 ] > 
 ] > >  ] 
 ] > >  ] actually here we have a nice example how MPLS can make things
 ] > >  ] overall much simpler; 
 ] > >  ] 
 ] > >  ] i know the v6 bigots do not like that take, but i am afraid
 ] > >  ] in the next years to come there won't be any 6-only networks;
 ] > > 
 ] > > i don't think we are talking about 6-only networks. people are
 ] > > mainly interested in dual-mode, transition and isolated single/dual
 ] > > mode islands in the networks. yes, mpls can be a way to bridge the
 ] > > transition(assume those networks want to use mpls in their backbones),
 ] > > but to my knowledge, to bridge some isolated V6 regions(still mostly
 ] > > dual-mode) together, it's so easy to use a couple of tunnels. i agree
 ] > > that one can use OSPF for ipv4 and ISIS/OSPFv3 for ipv6 to decouple the
 ] > > topologies in the domain, M-ISIS is just another simple way to create
 ] > > such a decoupled topologies. 
 ] > > 
 ] > >  ] /hannes
 ] > > 
 ] > > - Naiming
 ] > > 
 ] > > _______________________________________________
 ] > > Isis-wg mailing list
 ] > > [email-masked]
 ] > > https://www1.ietf.org/mailman/listinfo/isis-wg
 ] > 
 ] > 
 ] > 
 ] > _______________________________________________
 ] > Isis-wg mailing list
 ] > [email-masked]
 ] > https://www1.ietf.org/mailman/listinfo/isis-wg
 ] 
 ] 

- Naiming

---

From: Naiming Shen <[email-masked]>
Date: Tue, 29 Jul 2003 14:41:28 -0700

] Yeah, I messed up.
 ] But.....
 ] Suppose you label this tunnel as IPv6 only.
 ] How does the legacy IS-IS (not MT capable) know to ignore it ?

if the tunnel is ipv6-only link, then both routers at tunnel ends has
to be M-ISIS aware. and both routers send LSPs contain MT IS adjacency
records, other legacy routers do not understand those TLVs, thus they
don't even know this tunnel.

thanks.

 ] 
 ] It's still an IS-IS adjacency as far as legacy IS-IS is concerned.  Or isn't
 it ?
 ] 
 ] Philip
 ] 
 ] On 29 Jul 2003 at 14:14, Naiming Shen wrote:
 ] 
 ] >  ] This is where things get weird.
 ] >  ] 
 ] >  ] Suppose you have a real topology that goes A-B-C-D-E-F
 ] >  ] 
 ] >  ] So you make a tunnel from A to F because B-C-D-E don't support v6.
 ] >  ] 
 ] >  ] Do you want to make a static route to force the v6 packets down the tun
nel ?
 ] >  ] 
 ] >  ] Maybe not, so you run IS-IS over the tunnel as well.
 ] >  ] 
 ] >  ] Oh but the tunnel had better be more attractive to packets than the rea
l pat
 ] > h.
 ] >  ] 
 ] >  ] Now all your v4 packets go down the tunnel as well even though they don
't ne
 ] > ed to.
 ] >  ] 
 ] > 
 ] > Hur? i think you're talking about tunnels with "normal" IGP, but i was
 ] > talking about tunnels with M-ISIS. with M-ISIS, you just "label" this
 ] > tunnel link as ipv6-only, and ipv4 topology(thus spf) in your network
 ] > does not even know such a tunnel link exist. this is equivalent to use
 ] > ISIS for ipv4, but use ospfv3 on the tunnel links.
 ] > 
 ] > hope this helps.
 ] > 
 ] > thanks.
 ] > 
 ] >  ] So you have to run OSPFv3 on the tunnel instead and redistribute to IS-
IS at
 ] >  each end 
 ] >  ] or something.
 ] >  ] 
 ] >  ] I think autoencap is easier :-)
 ] >  ] 
 ] >  ] Philip
 ] >  ] 
 ] >  ] 
 ] >  ] 
 ] >  ] On 29 Jul 2003 at 11:27, Naiming Shen wrote:
 ] >  ] 
 ] >  ] >  ] 
 ] >  ] >  ] actually here we have a nice example how MPLS can make things
 ] >  ] >  ] overall much simpler; 
 ] >  ] >  ] 
 ] >  ] >  ] i know the v6 bigots do not like that take, but i am afraid
 ] >  ] >  ] in the next years to come there won't be any 6-only networks;
 ] >  ] > 
 ] >  ] > i don't think we are talking about 6-only networks. people are
 ] >  ] > mainly interested in dual-mode, transition and isolated single/dual
 ] >  ] > mode islands in the networks. yes, mpls can be a way to bridge the
 ] >  ] > transition(assume those networks want to use mpls in their backbones)
,
 ] >  ] > but to my knowledge, to bridge some isolated V6 regions(still mostly
 ] >  ] > dual-mode) together, it's so easy to use a couple of tunnels. i agree
 ] >  ] > that one can use OSPF for ipv4 and ISIS/OSPFv3 for ipv6 to decouple t
he
 ] >  ] > topologies in the domain, M-ISIS is just another simple way to create
 ] >  ] > such a decoupled topologies. 
 ] >  ] > 
 ] >  ] >  ] /hannes
 ] >  ] > 
 ] >  ] > - Naiming
 ] >  ] > 
 ] >  ] > _______________________________________________
 ] >  ] > Isis-wg mailing list
 ] >  ] > [email-masked]
 ] >  ] > https://www1.ietf.org/mailman/listinfo/isis-wg
 ] >  ] 
 ] >  ] 
 ] > 
 ] > - Naiming
 ] > 
 ] > _______________________________________________
 ] > Isis-wg mailing list
 ] > [email-masked]
 ] > https://www1.ietf.org/mailman/listinfo/isis-wg
 ] 
 ] 

- Naiming

---

From: Jeff Learman <[email-masked]>
Date: Tue, 29 Jul 2003 17:56:27 -0400

Philip, if I understand it correctly, you needn't run ISIS on an
MPLS tunnel, and it's dynamic anyway.  No static routes are needed.
The MPLS tunnel needn't be represented as a link in the topology.
Frankly, if you treated every label path as a link, you'd have a
serious scalability problem!  I'm talking "Basic MPLS".  Other
applications may be different.

All traffic from A to F gets tunneled, regardless of IPV6 or IPV4, no
problem.  The MPLS tunnel isn't treated by the routing protocols
like it's a link, and you don't run ISIS over it.  MPLS just provides
a magic carpet for those IPV6 packets to float over the IPV4 network
on ;)  The information from routing protocols causes the nodes to set
up the label network, and after that, each node locally makes the
decision whether to use a label path to forward a packet, rather than
native IP.  Interestingly enough, in an IPV4-only situation, these
decisions don't need to be made consistently by all routers -- if
some router neglects to tag a packet and IP-routes it, the next one
down the line can still tag it if it wants or not, and so on.

The only problem where you'd come into any difficulty is Penultimate
Hop Popping.  This is an optimization where the penultimate (second-
to-last) node in a label path pops the tag in order to even the load
between the edge and next-to-edge routers.  If you're using PHP but
the penultimate node in the label path isn't IPV6, you'd have trouble.
Presumably the IPV6 MPLS folks are well aware of this and have some
mechanism to avoid this problem, it's beyond my area of incompetence. ;)

The scenario I'm discussing is the standard Service Provider model
providing IPV6 services to customers, and running Basic MPLS in 
their core network on IPV4 routers.  If you want more flexibility
on where you're running IPV6, perhaps you'd need MT or auto-encap.
My head hurts when I think about MPLS in anything other than the
standard deployments; I don't understand it well enough to extrapolate.
Perhaps an MPLS guru can shed more light on whether there are
limitations on what it can do to bridge IPV4 seas between arbitrary
IPV6 islands.  But I can't think of any reason it wouldn't "just work",
other than the PHP thing.

Now, maybe I'm all wet on my (admittedly limited) understanding of
MPLS.  But as I see it, you have no need to run a separate routing
protocol or even use M-ISIS, as long as you have MPLS enabled in the
whole domain (or at least, in any IPV4 core, including any boundary
IPV6 nodes).  Or maybe there isn't a solution to the PHP problem.

Regards,
Jeff

Disclaimer: I don't work on ISIS at Cisco, and I don't represent
Cisco in these discussions.

---

From: [email-masked]
Date: Tue, 29 Jul 2003 23:21:52 +0100

Legacy routers will ignore the TLVs, but they won't ignore the fact that there is an IS-IS 
topology, and they will attempt to route over it.

You need that basic IS-IS topology in order to flood the MT TLVs, but you can't stop 
legacy IS-IS viewing it as a usable topology.

Even if the end points of the tunnel are M-ISIS aware, they still flood the LSPs onwards, 
and the non M-ISIS aware routers still see the adjacencies and plot a route through 
them, even though they don't understand the TLVs.

I have seen IP routers plot a route (and attempt to forward traffic) through an OSI-only 
router, and vice versa.  They are supposed to do that.

As far as SPF is concerned in a legacy router, what is the difference between an MT 
aware, IPv6 router, and an OSI router with some extra TLVs that it doesn't understand ?

No difference, it will plot the route.

Philip

---

From: Naiming Shen <[email-masked]>
Date: Tue, 29 Jul 2003 15:34:52 -0700

pls read the MT draft. other than that, i should only add that the main
purpose of M-ISIS is not letting legacy ipv4 routers 'see' any other
topologies. in the case of ipv4 and ipv6, just think of the M-ISIS as
isis running on ipv4, ospfv3 running on ipv6.

thanks.

 ] Legacy routers will ignore the TLVs, but they won't ignore the fact that the
re is an IS-IS 
 ] topology, and they will attempt to route over it.
 ] 
 ] You need that basic IS-IS topology in order to flood the MT TLVs, but you ca
n't stop 
 ] legacy IS-IS viewing it as a usable topology.
 ] 
 ] Even if the end points of the tunnel are M-ISIS aware, they still flood the 
LSPs onwards, 
 ] and the non M-ISIS aware routers still see the adjacencies and plot a route 
through 
 ] them, even though they don't understand the TLVs.
 ] 
 ] I have seen IP routers plot a route (and attempt to forward traffic) through
 an OSI-only 
 ] router, and vice versa.  They are supposed to do that.
 ] 
 ] As far as SPF is concerned in a legacy router, what is the difference betwee
n an MT 
 ] aware, IPv6 router, and an OSI router with some extra TLVs that it doesn't u
nderstand ?
 ] 
 ] No difference, it will plot the route.
 ] 
 ] Philip
 ] 
 ] On 29 Jul 2003 at 14:41, Naiming Shen wrote:
 ] 
 ] >  ] Yeah, I messed up.
 ] >  ] But.....
 ] >  ] Suppose you label this tunnel as IPv6 only.
 ] >  ] How does the legacy IS-IS (not MT capable) know to ignore it ?
 ] > 
 ] > if the tunnel is ipv6-only link, then both routers at tunnel ends has
 ] > to be M-ISIS aware. and both routers send LSPs contain MT IS adjacency
 ] > records, other legacy routers do not understand those TLVs, thus they
 ] > don't even know this tunnel.
 ] > 
 ] > thanks.
 ] > 
 ] >  ] 
 ] >  ] It's still an IS-IS adjacency as far as legacy IS-IS is concerned.  Or 
isn't
 ] >  it ?
 ] >  ] 
 ] >  ] Philip
 ] >  ] 
 ] >  ] On 29 Jul 2003 at 14:14, Naiming Shen wrote:
 ] >  ] 
 ] >  ] >  ] This is where things get weird.
 ] >  ] >  ] 
 ] >  ] >  ] Suppose you have a real topology that goes A-B-C-D-E-F
 ] >  ] >  ] 
 ] >  ] >  ] So you make a tunnel from A to F because B-C-D-E don't support v6.
 ] >  ] >  ] 
 ] >  ] >  ] Do you want to make a static route to force the v6 packets down th
e tun
 ] > nel ?
 ] >  ] >  ] 
 ] >  ] >  ] Maybe not, so you run IS-IS over the tunnel as well.
 ] >  ] >  ] 
 ] >  ] >  ] Oh but the tunnel had better be more attractive to packets than th
e rea
 ] > l pat
 ] >  ] > h.
 ] >  ] >  ] 
 ] >  ] >  ] Now all your v4 packets go down the tunnel as well even though the
y don
 ] > 't ne
 ] >  ] > ed to.
 ] >  ] >  ] 
 ] >  ] > 
 ] >  ] > Hur? i think you're talking about tunnels with "normal" IGP, but i wa
s
 ] >  ] > talking about tunnels with M-ISIS. with M-ISIS, you just "label" this
 ] >  ] > tunnel link as ipv6-only, and ipv4 topology(thus spf) in your network
 ] >  ] > does not even know such a tunnel link exist. this is equivalent to us
e
 ] >  ] > ISIS for ipv4, but use ospfv3 on the tunnel links.
 ] >  ] > 
 ] >  ] > hope this helps.
 ] >  ] > 
 ] >  ] > thanks.
 ] >  ] > 
 ] >  ] >  ] So you have to run OSPFv3 on the tunnel instead and redistribute t
o IS-
 ] > IS at
 ] >  ] >  each end 
 ] >  ] >  ] or something.
 ] >  ] >  ] 
 ] >  ] >  ] I think autoencap is easier :-)
 ] >  ] >  ] 
 ] >  ] >  ] Philip
 ] >  ] >  ] 
 ] >  ] >  ] 
 ] >  ] >  ] 
 ] >  ] >  ] On 29 Jul 2003 at 11:27, Naiming Shen wrote:
 ] >  ] >  ] 
 ] >  ] >  ] >  ] 
 ] >  ] >  ] >  ] actually here we have a nice example how MPLS can make things
 ] >  ] >  ] >  ] overall much simpler; 
 ] >  ] >  ] >  ] 
 ] >  ] >  ] >  ] i know the v6 bigots do not like that take, but i am afraid
 ] >  ] >  ] >  ] in the next years to come there won't be any 6-only networks;
 ] >  ] >  ] > 
 ] >  ] >  ] > i don't think we are talking about 6-only networks. people are
 ] >  ] >  ] > mainly interested in dual-mode, transition and isolated single/d
ual
 ] >  ] >  ] > mode islands in the networks. yes, mpls can be a way to bridge t
he
 ] >  ] >  ] > transition(assume those networks want to use mpls in their backb
ones)
 ] > ,
 ] >  ] >  ] > but to my knowledge, to bridge some isolated V6 regions(still mo
stly
 ] >  ] >  ] > dual-mode) together, it's so easy to use a couple of tunnels. i 
agree
 ] >  ] >  ] > that one can use OSPF for ipv4 and ISIS/OSPFv3 for ipv6 to decou
ple t
 ] > he
 ] >  ] >  ] > topologies in the domain, M-ISIS is just another simple way to c
reate
 ] >  ] >  ] > such a decoupled topologies. 
 ] >  ] >  ] > 
 ] >  ] >  ] >  ] /hannes
 ] >  ] >  ] > 
 ] >  ] >  ] > - Naiming
 ] >  ] >  ] > 
 ] >  ] >  ] > _______________________________________________
 ] >  ] >  ] > Isis-wg mailing list
 ] >  ] >  ] > [email-masked]
 ] >  ] >  ] > https://www1.ietf.org/mailman/listinfo/isis-wg
 ] >  ] >  ] 
 ] >  ] >  ] 
 ] >  ] > 
 ] >  ] > - Naiming
 ] >  ] > 
 ] >  ] > _______________________________________________
 ] >  ] > Isis-wg mailing list
 ] >  ] > [email-masked]
 ] >  ] > https://www1.ietf.org/mailman/listinfo/isis-wg
 ] >  ] 
 ] >  ] 
 ] > 
 ] > - Naiming
 ] 
 ] 
 ] 
 ] _______________________________________________
 ] Isis-wg mailing list
 ] [email-masked]
 ] https://www1.ietf.org/mailman/listinfo/isis-wg

- Naiming

---

From: [email-masked]
Date: Wed, 30 Jul 2003 10:20:50 +0100

I have read the draft (again).

Take this network A-B-C-D-E-F

A and F are MT aware.

So we configure a GRE/IPv4 tunnel from A to F.

In order for A and F to have an MT#2 adjacency over that tunnel, they have to have an 
ordinary IS-IS adjacency over the tunnel, and declare themselves adjacent to each 
other in their normal LSPs.  Then they add on the MT stuff as TLVs on top of this new 
adjacency.

Right or wrong ?

If that is right, then, if a legacy IS-IS router somewhere else in the network gets the 
normal LSP then it will consider the tunnel to be a usable route.

Suppose that B gets LSPs from A and F.

B might think that its best route to F is actually B-A-F and so will send all packets back 
to A.

The tunnel will I guess flap up and down if this happens as the GRE packets won't get 
through when the tunnel is "up", but will when it's "down".

Sorry to be a pain, but I really think I'm right on this.  If not then I'll have to eat humble 
pie (again) :-)

Philip

---

From: Albert Tian <[email-masked]>
Date: Wed, 30 Jul 2003 02:34:53 -0700

> other in their normal LSPs.  Then they add on the MT stuff as TLVs on top of this new

No, I believe they should not declare themselves adjacent in normal(non-MT)
LSPs. 

Thanks,

Albert

---

From: Hannes Gredler <[email-masked]>
Date: Wed, 30 Jul 2003 11:55:22 +0200

jeff, see answers/comments inline:

On Tue, Jul 29, 2003 at 05:56:27PM -0400, Jeff Learman wrote:
| 
| Philip, if I understand it correctly, you needn't run ISIS on an
| MPLS tunnel, and it's dynamic anyway.  No static routes are needed.
| The MPLS tunnel needn't be represented as a link in the topology.
| Frankly, if you treated every label path as a link, you'd have a
| serious scalability problem!  I'm talking "Basic MPLS".  Other
| applications may be different.
| 
| All traffic from A to F gets tunneled, regardless of IPV6 or IPV4, no
| problem.  The MPLS tunnel isn't treated by the routing protocols
| like it's a link, and you don't run ISIS over it.  MPLS just provides
| a magic carpet for those IPV6 packets to float over the IPV4 network
| on ;)  The information from routing protocols causes the nodes to set
| up the label network, and after that, each node locally makes the
| decision whether to use a label path to forward a packet, rather than
| native IP.  Interestingly enough, in an IPV4-only situation, these
| decisions don't need to be made consistently by all routers -- if
| some router neglects to tag a packet and IP-routes it, the next one
| down the line can still tag it if it wants or not, and so on.
| 
| The only problem where you'd come into any difficulty is Penultimate
| Hop Popping.  This is an optimization where the penultimate (second-
| to-last) node in a label path pops the tag in order to even the load
| between the edge and next-to-edge routers.  If you're using PHP but
| the penultimate node in the label path isn't IPV6, you'd have trouble.
| Presumably the IPV6 MPLS folks are well aware of this and have some
| mechanism to avoid this problem, it's beyond my area of incompetence. ;)

the way so solve that is that the tunnel-headend does a double-push
where the outerlabel is the "magic carpet" label and the inner is
IPv6 explicit null (2); now the penultimate router knows to
send it to the ultimate router using a v6 link layer protocol;
 
| The scenario I'm discussing is the standard Service Provider model
| providing IPV6 services to customers, and running Basic MPLS in 
| their core network on IPV4 routers.  If you want more flexibility
| on where you're running IPV6, perhaps you'd need MT or auto-encap.
| My head hurts when I think about MPLS in anything other than the
| standard deployments; I don't understand it well enough to extrapolate.
| Perhaps an MPLS guru can shed more light on whether there are
| limitations on what it can do to bridge IPV4 seas between arbitrary
| IPV6 islands.  But I can't think of any reason it wouldn't "just work",
| other than the PHP thing.
| 
| Now, maybe I'm all wet on my (admittedly limited) understanding of
| MPLS.  But as I see it, you have no need to run a separate routing
| protocol or even use M-ISIS, as long as you have MPLS enabled in the
| whole domain (or at least, in any IPV4 core, including any boundary
| IPV6 nodes).  Or maybe there isn't a solution to the PHP problem.

jeff is way right - there is no need to run M-ISIS or even
generate V6 TLVs at all;

tunneling V6 traffic over V4 MPLS tunnels is [depending on your
favourite router vendor] known as "6PE" or "V6-tunneling" -

many SPs like that approach where you have a single-topology-ipv4-only
IS-IS core and the edge routers run then MP-BGP to pass on the V6
island prefixes;

/hannes

---

From: Tony Przygienda <[email-masked]>
Date: Wed, 30 Jul 2003 14:06:33 +0200

>Sorry to be a pain, but I really think I'm right on this.  If not then I'll have to eat humble 
they're not adjacent in MT#0. read the draft carefully, pls. I think
section 5.1 is very clear about that.

-- tony

---

From: "Philip Christian" <[email-masked]>
Date: Wed, 30 Jul 2003 17:11:12 +0100

> section 5.1 is very clear about that.

okay, I now understand that an adjacency can exist between two routers as far as MT#n 
is concerned, without the legacy IS-IS adjacency (mt#0) being "up".  This makes such 
an adjacency invisible to legacy IS-IS.

Very clever..

This is not clearly stated anywhere in the draft, and most certainly not in section 5.1.

Section 5.1 says what is advertised in MT bit of LSPs, but not what is advertised in parts 
of the LSP readable by legacy implementations.

Moreover, section 5.1 talks about "topology based LSPs" but the draft does not really 
define what a "topology based LSP" is.  I think actually it means an MT TLV relating to a 
particular MT topology.  Anyway the term is a bit too vague.

Moreover in the abstract it says "This draft describes how to run within a single ISIS 
domain a set of independent IP topologies that we call Multi-Topologies (MTs)."  but 
actually you are now talking about MTs that are not "within" the ISIS domain, because 
the legacy ISIS domain doesn't go over that tunnel.

I think that there is a strong risk of a new implementer coming along and not realising 
that you can have an adjacency up and declared in an MT without it being up in the 
legacy ISIS and making a horrid interoperability problem.

It needs to be clearly stated.

Philip

---

From: Naiming Shen <[email-masked]>
Date: Wed, 30 Jul 2003 11:03:10 -0700

Using mpls is a good approach, but the conclusion here is only
partially correct.

Follow the same logic, we should say OSPFv3 is useless and not needed,
since if we have OSPFv2, we have MPLS and we have BGP, why do we
need OSPFv3? why not just run 6PE everywhere in every network?

We seem to be mixing the IGP with BGP or 'overloaded-BGP'.
IGP is used for intradomain paths to connect internal routers together.
while 6PE does the job to transport ISP's customer v6 data across
ISP's v4 backbone, this assumes also the network using v4 ibgp peers,
the whole network is mpls enabled, providers want to use the v4
topology for v6 traffic with no change. Otherwise, if the network
does want to enable native v6 internally, if they do want to run
a different topology than the v4 topology(e.g. two links between
two nodes, they want to run v4 on the GE link, but v6 on the FE
link), if the network is not running bgp-mpls-vpn or even mpls,
then operators may want to run a v6 IGP in part of their network.

But if your comment meant for the people using mpls transport v6
data and v6 IGP is not needed, then I completely agree.

thanks.

 ] 
 ] jeff is way right - there is no need to run M-ISIS or even
 ] generate V6 TLVs at all;
 ] 
 ] tunneling V6 traffic over V4 MPLS tunnels is [depending on your
 ] favourite router vendor] known as "6PE" or "V6-tunneling" -
 ] 
 ] many SPs like that approach where you have a single-topology-ipv4-only
 ] IS-IS core and the edge routers run then MP-BGP to pass on the V6
 ] island prefixes;
 ] 
 ] /hannes

- Naiming

---

From: Tony Przygienda <[email-masked]>
Date: Wed, 30 Jul 2003 21:41:38 +0200

>It needs to be clearly stated.
<individual>
Philip, I dare to disagree here, when section 5.1 says

If local router does
    not participate in certain MTs, it will not advertise those MTIDs
    in it's IIHs and thus will not include that neighbor within it's
    topology based LSPs.  On the other hand, if a MTID is not
    detected in remote side's IIHs, the local router MUST NOT include
    that neighbor within it's MT LSPs. The local router SHOULD NOT form
    adjacency if they don't have at least one common MT set over the
    interface.

which clearly implies that you maintain an adjaceny _per topology_ and 
there is no _implicit #0 adjacency_. 

In 5.2 however 

Two Routers on a LAN SHALL always establish adjacency regardless
    whether they have common MT set or not. This is to ensure all
    the routers on the LAN can correctly elect the same DIS. The IS
    SHOULD NOT include the MT IS TLV in its LSP if none of the
    adjacencies on the LAN contains this MT.

clearly describes an _implicit adjacency_.

But ok, let's say, clarifying can't hurt so as editorial fix what 
would be the clarifying sentence you would like to add ? 

BTW, IMHO there will be no interop problem if an implementor screws up since
the backlink will be always missing for the SPF ...

	thanks 

	---tony

</individual>

---

From: Hannes Gredler <[email-masked]>
Date: Thu, 31 Jul 2003 08:52:41 +0200

hi naiming,

answers/comments inline;

On Wed, Jul 30, 2003 at 11:03:10AM -0700, Naiming Shen wrote:
| 
| Using mpls is a good approach, but the conclusion here is only
| partially correct.
| 
| Follow the same logic, we should say OSPFv3 is useless and not needed,
| since if we have OSPFv2, we have MPLS and we have BGP, why do we
| need OSPFv3? why not just run 6PE everywhere in every network?

i won't comment if OSPFv{2,3} i useless or not ;-) - 
let me put it that way: going down the protocol maturity curve for
a new routing protoccol [OSPFv3] in order to establish a 
control-plane that will be redundant [i.e. v4 already there]
is a risk that nat everybody wants to afford;
 
rather than taking the pain of maturing OSPFv3 SPs are more willing
to turn on MPLS as all major implmentations are mature and
interoperable these days;

| We seem to be mixing the IGP with BGP or 'overloaded-BGP'.

conveying V6 routes in BGP is IMHO not overloading;

| IGP is used for intradomain paths to connect internal routers together.
| while 6PE does the job to transport ISP's customer v6 data across
| ISP's v4 backbone, this assumes also the network using v4 ibgp peers,
| the whole network is mpls enabled, providers want to use the v4
| topology for v6 traffic with no change. Otherwise, if the network
| does want to enable native v6 internally, if they do want to run
| a different topology than the v4 topology(e.g. two links between
| two nodes, they want to run v4 on the GE link, but v6 on the FE
| link), if the network is not running bgp-mpls-vpn or even mpls,
| then operators may want to run a v6 IGP in part of their network.

another possibility would be to force your V6 traffic to use a certain
tunnel that is different form the shortest path ....

you have used the term "overload" - don't we run risk that with MT
we are trying to "overload" light TE functions in the IGP ?
 the best argument for MT so far is traffic-control over
 non-congurnet topologies - i'll ask myself how much traffic control
 functions do we want to piggyback to our IGPs ?

| But if your comment meant for the people using mpls transport v6
| data and v6 IGP is not needed, then I completely agree.

what i tried to say is that on the list we are doing a discussion purely
about technology - however the deployement reality [=SPs] tell(s) us
that the problem has already been solved and further evolvement of
the protocol is not needed;

/hannes

|  ] 
|  ] jeff is way right - there is no need to run M-ISIS or even
|  ] generate V6 TLVs at all;
|  ] 
|  ] tunneling V6 traffic over V4 MPLS tunnels is [depending on your
|  ] favourite router vendor] known as "6PE" or "V6-tunneling" -
|  ] 
|  ] many SPs like that approach where you have a single-topology-ipv4-only
|  ] IS-IS core and the edge routers run then MP-BGP to pass on the V6
|  ] island prefixes;
|  ] 
|  ] /hannes